#include <cstdio>
#include <map>
#include <set>
#include <cassert>

using namespace std;

#define FUMP(x, y) ((x)+(y)*64)

typedef long long ll;

const int maxn = 200009*64;
ll arr[200009];
set<pair<int, int>> ranges[64];
int p[maxn];
int r[maxn];

int Find(int a)
{
	if(p[a] == a)
		return a;
	p[a] = Find(p[a]);
	return p[a];
}

void Union(int a, int b)
{
	//printf("Union of %d,%d and %d,%d\n", a%64, a/64, b%64, b/64);
	a = Find(a);
	b = Find(b);
	if(a == b)
		return;
	if(r[a] > r[b])
	{
		p[b] = a;
	}
	else if(r[a] < r[b])
	{
		p[a] = b;
	}
	else
	{
		p[b] = a;
		r[a]++;
	}
}

void insert(pair<int, int> p1, pair<int, int> p2) {
	for (int x=p1.first; x<=p2.first; x++) {
		int L = p1.second;
		int R = p2.second;
		pair<int, int> newrange{L, R};
		if (arr[L-1] & (1ll<<(x))) {
			Union(FUMP(x, L), FUMP(x, L-1));
		}
		while (L<=R) {
			if (x == 6) {
				//printf("x=6, L=%d\n", L);
			}
			Union(FUMP(x, L), FUMP(x, L+1));
			if (arr[L] & (1ll<<(x+1))) {
				Union(FUMP(x, L), FUMP(x+1, L));
			}
			if (arr[L] & (1ll<<(x-1))) {
				Union(FUMP(x, L), FUMP(x-1, L));
			}
			if (arr[L] & (1ll<<x)) {
				auto it = ranges[x].upper_bound({L, 1e9});
				assert(it != ranges[x].begin());
				it--;
				//printf("Water at %d %d! contained by [%d, %d]\n", x, L, it->first, it->second);
				newrange.first = min(newrange.first, it->first);
				newrange.second = max(newrange.second, it->second);
				arr[L] |= 1ll<<x;
				L = it->second;
				ranges[x].erase(it);
			}
			arr[L] |= 1ll<<x;
			L++;
		}
		if (arr[R+1] & (1ll<<(x))) {
			Union(FUMP(x, R), FUMP(x, R+1));
		}
			if (arr[R] & (1ll<<(x+1))) {
				Union(FUMP(x, R), FUMP(x+1, R));
			}
			if (arr[R] & (1ll<<(x-1))) {
				Union(FUMP(x, R), FUMP(x-1, R));
			}
		arr[R] |= 1ll<<x;
		ranges[x].insert(newrange);
	}
}

void query(pair<int, int> p1, pair<int, int> p2) {
	bool same = (Find(FUMP(p1.first, p1.second)) == 
			Find(FUMP(p2.first, p2.second)));
	printf("%d\n", same);
}

int main() {
	for (int i=0; i<maxn; i++) p[i] = i;
	int l;
	scanf("%d", &l);
	while (l--) {
		int t, x1, y1, x2, y2;
		scanf("%d %d %d %d %d", &t, &x1, &y1, &x2, &y2);
		/*printf("Current ranges:\n");
		for (int x=0; x<64; x++) {
			for (auto range: ranges[x]) {
				printf("x=%d, [%d,%d]\n", x, range.first, range.second);
			}
			for(int y=0; y<100; y++){
				if(arr[y] & (1ll<<x)) printf("wtr at %d %d\n", x, y);
			}
		}*/
		if (x1 > x2) swap(x1, x2);
		if (y1 > y2) swap(y1, y2);
		pair<int, int> p1{x1, y1}, p2{x2, y2};
		if (t == 0) insert(p1, p2);
		else query(p1, p2);
	}
}
